From d134024f7850de8111bb7af707e5cab2fd2bd973 Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Fri, 19 Nov 2010 23:17:36 +0900
Subject: [PATCH 44/51] supported multiply nested methods.

---
 vm.c |    7 ++++++-
 1 files changed, 6 insertions(+), 1 deletions(-)

diff --git a/vm.c b/vm.c
index 9ced8d4..59dd4c4 100644
--- a/vm.c
+++ b/vm.c
@@ -1884,7 +1884,12 @@ vm_define_method(rb_thread_t *th, VALUE obj, ID id, VALUE iseqval, VALUE nested,
 	else {
 	    c = klass;
 	}
-	target = find_module_for_nested_methods(cref, c);
+	if (cref->flags & NODE_FL_CREF_OMOD_SHARED) {
+	    target = Qnil;
+	}
+	else {
+	    target = find_module_for_nested_methods(cref, c);
+	}
 	if (NIL_P(target)) {
 	    target = rb_module_new();
 	    FL_SET(target, RMODULE_HAS_NESTED_METHODS);
-- 
1.7.0.4

